/* all to all */

#include <stdio.h>
#include <signal.h>
#include <mmm/net_lib.h>
#include <mmm/io_lib.h>
#include <mmm/ioext.h>
#include <mmm/ionet_lib.h>

int forwarder( io_t *io, int what, void *arg );

io_t *global_io=NULL;

/* io_t prototyp for io-tasks reading and writing to socket */
io_t io_proto= proto_io	(	1,		/* prior */
				iof_input_line,	/* func */
				forwarder,	/* ufn */
				NULL,NULL	/* ptr, ptr2 */
			);

void terminate( int signum )
{
	io_exit(global_io,1);
}

int conn( io_t *io, int what, void *arg )
{ io_t *o;
	if( what == IO_RD )
	{	if( (o=io_find(io,io->user_id))!=NULL )
		{ if( io_bufwrite(o,io->inbuf) < 0 ) return(-1); }
		else	return(-1);
		dfifo_clear(io->inbuf);
	}
	else if( what == IO_WR )
		return(io_writebuf_erase(io));
	else if( what == IO_WREXTR )
	{	io->outbuf=NULL;
		io_call(io,io->user_id,100,NULL);
		printf("extra\n");
	}
	else if( what == IO_INIT )
	{	io->user_id=io->caller;
		if( io->outbuf==NULL )	io->outbuf=NOTNULL;
		return( io_call(io,io->user_id,IO_HELLO,NULL) );
	}
	else if( what == IO_DEL )
	{
		io_call(io,io->user_id,IO_DEL,NULL);
	}
	return(0);
}

int forwarder( io_t *io, int what, void *arg )
{ ioextend_t *e;
  char *p;
  int i;
  unsigned int x;
  io_t *o;
	if( what == IO_RD )
	{	if( io->user2==100 )
		{   if( (o=io_find(io,io->user_id))!=NULL )
		    { if( io_bufwrite(o,io->inbuf) < 0 ) return(-1); }
		    else { printf("peer died.\n"); return(-1); }
		    dfifo_clear(io->inbuf);
		    return(0);
		}
		if( (e=io_extend_find(io,1))==NULL )	return(-1);
		p=dfifo_data((dfifo_t*)(io->inbuf));
		i=dfifo_n((dfifo_t*)(io->inbuf));
		while( i>0 && ( p[i-1]=='\n' || p[i-1]=='\r' ) )	i--;
		p[i]=0;
		if( io->user2 == 0 )
		{	
			if( net_name2ip(p,&x)<=0 )
			{	
				io_printf(io,"%s: Unknown host!\n",p);
				io_chrd(io,-1);
			}
			else
			{
				e->num=x; io->user2++;
				io_printf(io,"Enter port: ");
			}
		}
		else if( io->user2 ==1 )
		{	if( (e->num1=net_text2port(p,"tcp"))<=0 )
			{	io_printf(io,"%s: Unknown port/service!\n",p);
				io_chrd(io,-1);
			}
			else
			{  io_t new;
			   io->func=iof_in_out;
			   new=*io;	new.ufn=conn;
			   new.rd=new.wr=new.ex=-1;
			   new.inbuf=new.outbuf=new.ptr2=new.ptr=NULL;
			   io_chtimer(io,5000,0);
			   if( ionet_connect(io,&new,e->num,e->num1)<0 )
			   {	io_printf(io,"Can't Fork!\n");
			   	return(-1);
			   }
			   io->user2=100;
			}
		}
		dfifo_clear(io->inbuf);
	}
	else if( what == IO_WR )
		return(io_writebuf_erase(io));
	else if( what == IO_TM )
	{	io_printf(io,"Conection timeout!\n",p);
		io_chrd(io,-1);
	}
	else if( what == IO_INIT )
	{	if( io_extend_init(io,16)<=0 )	return(-1);
		if( (e=io_extend_alloc( io, 1 ))==NULL )	return(-1);
		io->user2=0;
		io->user_id=IO_NULLID;
		if( (io->user1=ioext_stack_create(io))<=0 )	return(-1);
		io_chtimer(io,10000,0);
		io_printf(io,"Wellcome\n\nEnter adress: ");
	}
	else if( what == IO_DEL )
	{	ioext_stack_del(io,io->user1);
		io_extend_del(io);
		io_call(io,io->user_id,IO_DEL,NULL);
	}
	else if( what ==IO_HELLO )	io->user_id=io->caller;
	else if( what ==100 )	io_chtimer(io,0,0);
	return(0);
}

int main( void )
{ io_t *io;
  int r;
	if( (io=io_init(NULL))==NULL )	return(-1);
	global_io=io;
	signal(SIGTERM,terminate);
	if( (r=ionet_bind(io,&io_proto,3000))<0 )
	{	printf("Can't bind to port! error:%d\n",r);
		return(-1);
	}
	r=io_do(io);
	printf("EXIT: %d\n",r);
	io_final(io);
	return(0);
}

