
#ifndef _LIBC_SYMS_H
#define _LIBC_SYMS_H
#include <mmm/modules.h>

mod_syms_t libc_syms[]=	{
#ifdef _STDIO_H

	SD(_IO_stdin_), SD(_IO_stdout_), SD(_IO_stderr_),
	SF(clearerr ), SF(fclose), SF(feof), SF(ferror), SF(fflush),
	SF(fgetc), SF(fgetpos), SF(fgets), SF(fopen), SF(fprintf), SF(fputc),
	SF(fputs), SF(fread), SF(freopen), SF(fscanf), SF(fseek),
	SF(fsetpos), SF(ftell), SF(fwrite), SF(getc), SF(getchar),
	SF(gets), SF(perror), SF(printf), SF(putc), SF(putchar), SF(puts),
	SF(remove), SF(rename), SF(rewind), SF(scanf), SF(setbuf),
	SF(setlinebuf), SF(setbuffer), SF(setvbuf), SF(sprintf),
	SF(sscanf), SF(tmpfile), SF(tmpnam), SF(ungetc), SF(vfprintf),
	SF(vprintf), SF(vsprintf),
#if !defined(__STRICT_ANSI__)
	SF(vfscanf), SF(vscanf), SF(vsscanf), SF(getw), SF(putw), SF(tempnam),
#ifdef __GNU_LIBRARY__
#ifdef  __USE_BSD
	SD(sys_nerr), SD(sys_errlist),
#endif
#ifdef  __USE_GNU
	SD(_sys_nerr), SD(_sys_errlist),
#endif
#ifdef  __USE_MISC
	SF(psignal),
#endif /* Non strict ANSI and not POSIX only.  */
#endif /* __GNU_LIBRARY__ */
#endif /* __STRICT_ANSI__ */
#ifdef __USE_GNU
	SF(getdelim),
#if 0 
	SF(getline),
#endif
	SF(snprintf), SF(vsnprintf), SF(asprintf), SF(vasprintf),
#endif
#if !defined(__STRICT_ANSI__) || defined(_POSIX_SOURCE)
	SF(fdopen), SF(fileno), SF(popen), SF(pclose), SF(ctermid),
	SF(cuserid),
#endif
	SF(__underflow), SF(__overflow),
#if defined(_POSIX_THREAD_SAFE_FUNCTIONS) || defined(_REENTRANT)
	SF(flockfile), SF(funlockfile), SF(ftrylockfile),
#endif
#endif	_STDIO_H

#ifdef	_STDLIB_H
	SF(atof), SF(atoi), SF(atol),
#if __GNUC__ >= 2 && defined(__USE_GNU) && !defined(__STRICT_ANSI__)
//	SF(atoq),
#endif
	SF(strtof), SF(strtod),
#if __GNUC__ >= 2 && defined(__USE_GNU)
	SF(strtold),
#endif
	SF(strtol), SF(strtoul),
#if __GNUC__ >= 2 && defined(__USE_GNU) && !defined(__STRICT_ANSI__)
	SF(strtoq), SF(strtouq),
#endif
	SF(__strtod_internal), SF(__strtof_internal), SF(__strtold_internal),
	SF(__strtol_internal), SF(__strtoul_internal),
#if __GNUC__ >= 2 && defined(__USE_GNU) && !defined(__STRICT_ANSI__)
	SF(__strtoq_internal), SF(__strtouq_internal),
#endif
	SF(rand), SF(srand), SF(__random), SF(__srandom), SF(__initstate),
	SF(__setstate),
#ifdef	__USE_BSD
	SF(random), SF(srandom), SF(initstate), SF(setstate),
#endif /* Use BSD.  */
	SF(malloc), SF(realloc), SF(calloc), SF(free),
#ifdef	__USE_MISC
	SF(cfree),
#endif /* Use misc.  */
#ifdef	__USE_BSD
	SF(valloc),
#endif
	SF(abort), SF(atexit),
#ifdef	__USE_MISC
	SF(on_exit),
#endif
	SF(exit), SF(getenv),
#if defined(__USE_SVID) || defined(__USE_BSD)
	SF(putenv),
#endif
#ifdef	__USE_BSD
	SF(setenv),
#endif
	SF(system), SF(bsearch), SF(qsort), SF(abs),
	SF(labs), SF(div), SF(ldiv), SF(mblen), SF(mbtowc), SF(wctomb),
	SF(mbstowcs), SF(wcstombs),
#if defined(__USE_MISC)
	SD(environ), SD(__environ), SF(ecvt), SF(fcvt), SF(gcvt), SF(drand48),
	SF(erand48), SF(lrand48), SF(nrand48), SF(mrand48), SF(jrand48),
	SF(srand48), SF(seed48), SF(lcong48), SF(setenv), SF(unsetenv),
	SF(insque), SF(remque),
#endif	/* __USE_MISC */
#endif	_STDLIB_H

#ifdef	_UNISTD_H
	SF(__access), SF(access), SF(__lseek), SF(lseek),
#if defined(__USE_MISC) && defined(__GNUC__) && !defined(__STRICT_ANSI__)
	SF(__llseek), SF(llseek),
#endif
	SF(__close), SF(close), SF(__read), SF(read), SF(__write), SF(write),
	SF(__pipe), SF(pipe), SF(alarm), SF(sleep), SF(pause), SF(__chown),
	SF(chown),
#ifdef	__USE_BSD
	SF(__fchown), SF(fchown), SF(__fchdir), SF(fchdir),
#endif /* Use BSD.  */
	SF(__chdir), SF(chdir), SF(getcwd),
#ifdef	__USE_GNU
	SF(get_current_dir_name),
#endif
#ifdef	__USE_BSD
	SF(getwd),
#endif
	SF(__dup), SF(dup), SF(__dup2), SF(dup2), SD(__environ), SD(environ),
	SF(__execve), SF(execve), SF(execv), SF(execle), SF(execl), SF(execvp),
	SF(execlp), SF(_exit), SF(__pathconf), SF(pathconf), SF(__fpathconf),
	SF(fpathconf), SF(__sysconf), SF(sysconf),
#ifdef	__USE_POSIX2
	SF(confstr),
#endif
	SF(__getpid), SF(getpid), SF(__getppid), SF(getppid),
#ifdef __linux__
	SF(getpgid), SF(getpgrp), SF(setpgid), SF(setpgrp),
#else
	SF(__getpgrp),
#ifndef	__FAVOR_BSD
	SF(getpgrp),
#endif
	SF(__setpgrp), SF(setpgid),
#ifdef	__USE_BSD
	SF(setpgrp),
#endif /* Use BSD.  */
#endif /* __linux__ */
	SF(__setsid), SF(setsid), SF(__getsid), SF(getsid), SF(__getuid),
	SF(getuid), SF(__geteuid), SF(geteuid), SF(__getgid), SF(getgid),
	SF(__getegid), SF(getegid), SF(__getgroups), SF(getgroups),
	SF(__setuid), SF(setuid),
#ifdef	__USE_BSD
	SF(__setreuid), SF(setreuid), SF(seteuid),
#endif /* Use BSD.  */
	SF(__setgid), SF(setgid),
#ifdef	__USE_BSD
	SF(__setregid), SF(setregid), SF(setegid),
#endif /* Use BSD.  */
	SF(__setfsuid), SF(setfsuid), SF(__setfsgid), SF(setfsgid),
	SF(__fork), SF(fork),
#ifdef	__USE_BSD
	SF(__vfork), SF(vfork),
#endif /* Use BSD. */
#if 0
	SF(cuserid), SF(ctermid),
#endif
	SF(ttyname), SF(__isatty), SF(isatty), SF(__link), SF(link),
#ifdef	__USE_BSD
	SF(__symlink), SF(symlink), SF(__readlink), SF(readlink),
#endif /* Use BSD.  */
	SF(__unlink), SF(unlink), SF(__rmdir), SF(rmdir), SF(tcgetpgrp),
	SF(tcsetpgrp), SF(getlogin),
#ifdef	__USE_BSD
//	SF(setlogin),
#endif
#ifdef	__USE_POSIX2
	SF(getopt), SD(opterr), SD(optind), SD(optopt), SD(optarg),
#endif
#ifdef	__USE_BSD
	SF(__gethostname), SF(gethostname), SF(sethostname), SF(gethostid),
	SF(sethostid), SF(__getpagesize), SF(getpagesize), SF(__getdtablesize),
	SF(getdtablesize), SF(fdatasync), SF(fsync), SF(sync), SF(vhangup),
	SF(acct), SF(chroot), SF(swapon), SF(getusershell), SF(endusershell),
	SF(setusershell), SF(getpass),
#endif /* Use BSD.  */
#if defined (__USE_MISC) && !defined (F_LOCK)
	SF(lockf),
#endif /* Use misc and F_LOCK not already defined.  */
#ifdef __USE_MISC
	SF(__brk), SF(brk), SF(__sbrk), SF(sbrk), SF(crypt), SF(encrypt),
	SF(setkey), SF(ftruncate), SF(truncate), SF(ioperm ), SF(iopl),
	SF(mktemp), SF(mkstemp), SF(nice), /*SF(profil),*/ SF(usleep), SF(_xustat),
	SF(idle), SF(reboot), SF(swapoff), SF(uselib), SF(getdomainname),
	SF(setdomainname), SF(realpath),
#if 0
	SF(basename),
#endif
#endif
#if defined(_POSIX_THREAD_SAFE_FUNCTIONS) || defined(_REENTRANT)
	SF(ttyname_r),
#endif
#endif	_UNISTD_H

#ifdef _FCNTL_H
	SF(creat), SF(fcntl), SF(__fcntl), SF(open), SF(__open),
#if defined (__USE_MISC) && !defined (F_LOCK)
	SF(lockf),
#endif
#endif _FCNTL_H

#ifdef _SYS_STAT_H
	SF(_fxstat), SF(_xstat), SF(_lxstat),
#ifdef _MIT_POSIX_THREADS
	SF(__machdep_sys__fxstat),
#endif
	SF(_xmknod), SF(__chmod), SF(chmod), SF(__fchmod), SF(fchmod),
	SF(__mkdir), SF(mkdir), SF(mkfifo),
#if 0
	SF(__fstat), SF(fstat), SF(__stat), SF(stat), SF(__lstat), SF(lstat),
	SF(__mknod), SF(mknod),
#endif		/* #if 0 */
	SF(__umask), SF(umask),
#endif _SYS_STAT_H

#ifdef _SYS_MMAN_H
	SF(mmap), SF(munmap), SF(mprotect), SF(msync), SF(mlock), SF(munlock),
	SF(mlockall), SF(munlockall), SF(mremap),
#endif _SYS_MMAN_H
	SE
			};
#endif _LIBC_SYMS_H

