/* ioext functions
 * (c) by Marek Zelem
 */

#include <mmm/io_lib.h>
#include "ext_magic.h"

/* ------- STACK -------- */

short ioext_stack_create( io_t *io )
{ ioextend_t *e;
  short m;
  	m=EXTMAGIC_STACK;
	while( m<=EXTMAGIC_STACK_LAST )
	{	if( io_extend_find(io,m)==NULL )
		{	if( (e=io_extend_alloc(io,m))==NULL )
				return(-1);
			if( (e->ptr=dfifo_create(sizeof(void*),16))==NULL )
			{	io_extend_release(io,m);
				return(-2);
			}
			return(m);
		}
	}
	return(-1);
}

int ioext_stack_del( io_t *io, short magic )
{ ioextend_t *e;
	if( (e=io_extend_find(io,magic))==NULL )
		return(0);
	if( e->ptr!=NULL )	dfifo_delete( e->ptr );
	return(io_extend_release(io,magic));
}

int ioext_stack_push( io_t *io, int magic, void *ptr )
{ ioextend_t *e;
	if( (e=io_extend_find(io,magic))==NULL )	return(-1);
	return(dfifo_write(e->ptr,&ptr,1));
}

void *ioext_stack_pop( io_t *io, int magic )
{ ioextend_t *e;
  void *ptr;
	if( (e=io_extend_find(io,magic))==NULL )	return(NULL);
	if( dlifo_read(e->ptr,&ptr,1)!=1 )
		return(NULL);
	return(ptr);
}

/* ---------- REGISTER --------- */
/*
int ioext_register_create( io_t *io )
{ ioextend_t *e;
	if( io_extend_find(io,EXTMAGIC_REGISTER)==NULL )
	{	if( (e=io_extend_alloc(io,m))==NULL )
			return(-1);
		if( (e->ptr=dd_alloc(sizeof(io_t*),16))==NULL )
		{	io_extend_release(io,m);
			return(-2);
		}
		return(m);
	}
	return(-1);
}

int ioext_register_del( io_t *io )
{ ioextend_t *e;
	if( (e=io_extend_find(io,EXTMAGIC_REGISTER))==NULL )
		return(0);
	if( e->ptr!=NULL )	dfifo_delete( e->ptr );
	return(io_extend_release(io,EXTMAGIC_REGISTER));
}
*/

