/* User Interface - Menu
 * (c) by Marek Zelem
 */

#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <mmm/menu.h>

int menu_exec_function( int fd, vars_t *vars, vars_t *local, menu_t *menu )
{ char *param;
  char *pp,*ppp,*v;
  long r,*p,pn,ps;
  	p=NULL;	pn=0; ps=0;
  	if( menu->param_dec!=NULL )
	{
  	if( (param=strdup(menu->param_dec))==NULL )	goto End;
	pp=param;
	while( pp!=NULL )
	{	while( *pp==' ' || *pp=='\t' )	pp++;
		if( (ppp=strchr(pp,','))!=NULL )
		{	*ppp=0;	ppp++;	}
		if( (v=strchr(pp,'='))!=NULL )
		{	*v=0; v++;
			r=type_str_input(v,pp,vars->types);
		}
		else if( *pp!=0 )
		{  val_err=1; r=0;
		   if( local!=NULL )
			   r=var_getval(local,pp);
		   if( val_err && menu->func!=NULL )
			   r=var_getval(vars,pp);
		   if( val_err )
		   {	r=type_input(fd,pp,vars->types);
			if( local!=NULL )	var_set(local,pp,r);
		   }
		}
		if( *pp!=0 )
		{	if( p==NULL )
			{	pn=0; ps=8;
				if( (p=malloc(ps*sizeof(long)))==NULL )
					goto End;
			}
			if( pn>=ps )
			{	ps+=8;
				if( (p=realloc(p,ps*sizeof(long)))==NULL )
					goto End;
			}
			p[pn++]=r;
		}
		pp=ppp;
	}
	free(param);
	}
	if( menu->func!=NULL )
	{	r=func_call(menu->func,p,pn);
		if( menu->retval_dec!=NULL )
			var_set(vars,menu->retval_dec,r);
	}
	if( p!=NULL )	free(p);
End:	return(0);
}

int cmdcmp( const char *cmd, const char *line )
{
	while( *cmd==*line )
	{	if( *cmd==0 )	return(0);
		cmd++;	line++;
	}
	if( *cmd==0 && (*line==' ' || *line=='\t') )
		return(0);
	return(1);
}

static int menu_print_help( int fd, menu_t *menu )
{ int i,p;
  char buf[1024];
	for(i=0;menu[i].typ!=MENU_END;)
	{	p=0;	buf[p]=0;
		if( (menu[i].typ==MENU_ITEM || menu[i].typ==MENU_EXIT
				|| (menu[i].typ & MENU_MASK)==MENU_SUB)
		    && menu[i].help!=NULL )
		{
		snprintf(buf+p,1023-p,"  %-10s",menu[i].command);
		p+=strlen(buf+p);
		snprintf(buf+p,1023-p," - %s",menu[i].help);
		p+=strlen(buf+p);
		write(fd,buf,p);
		write(fd,"\n",1);
		}
		i++;
	}
	return(0);
}

MENU_t *menu_init( int fd, types_t *types, menu_t *menu, vars_t *vars )
{ int i,n;
  char *p;
  MENU_t *m;
  	if( (m=malloc(sizeof(MENU_t)))==NULL )
		return(NULL);
	memset(m,0,sizeof(MENU_t));
	m->prev=NULL;
	m->prompt=NULL;
	m->retvars=NULL;
	m->menu=menu;
	m->fd=fd;
	if( vars==NULL )
	{	if( (m->vars=var_init(types))==NULL )
			goto Err;
	}
	else	m->vars=vars;
	var_set(m->vars,"int fd",(long)fd);
	n=0;
	for(i=0;menu[i].typ!=MENU_END;)
	{	if( menu[i].typ==(MENU_INIT|n) )
		{	if( menu[i].command!=NULL )
			{	if( m->prompt!=NULL )	free(m->prompt);
				m->not_found=NULL;
				m->prompt=strdup(menu[i].command);
				p=m->prompt;
				while( *p!=0 && *p!='|' ) p++;
				if( *p=='|' )
				{	*p=0;	p++;
					m->not_found=p;
				}
			}
			/* if( menu[i].func!=NULL ) */
			    menu_exec_function(fd,m->vars,m->vars,&(menu[i]));
			n++;
			i=0; continue;
		}
		i++;
	}
	return(m);
Err:	if( m->vars!=NULL )	var_stop(m->vars);
	if( m->prompt!=NULL )	free(m->prompt);
	free(m);
	return(NULL);
}

static int menu_extern_vars( vars_t *to, char *par, vars_t *from )
{ char *param;
  char *pp,*ppp,*v;
  long r;
  	if( (param=strdup(par))==NULL )	return(-1);
	pp=param;
	while( pp!=NULL )
	{	while( *pp==' ' || *pp=='\t' )	pp++;
		if( (ppp=strchr(pp,','))!=NULL )
		{	*ppp=0;	ppp++;	}
		if( (v=strchr(pp,'='))!=NULL )
		{	*v=0; v++;
			r=type_str_input(v,pp,to->types);
			val_err=0;
		}
		else if( *pp!=0 )
		{	r=var_getval(from,pp);
			if( !val_err )
			{	r=type_dup(pp,from->types,r);
				val_err=0;
			}
		}
		if( *pp!=0 && !val_err )
		{	var_set(to,pp,r);
		}
		pp=ppp;
	}
	free(param);
	return(0);
}

MENU_t *menu_exit( MENU_t *m )
{ MENU_t *prev;
	menu_do_command(m,MENU_FINISH,"");
	prev=m->prev;
	if( m->retvars!=NULL )
	{  if( prev!=NULL )
	   	menu_extern_vars(prev->vars,m->retvars,m->vars);
	   free(m->retvars);
	}
	if( m->vars!=NULL )	var_stop(m->vars);
	if( m->prompt!=NULL )	free(m->prompt);
	free(m);
	return(prev);
}

int menu_setvar( MENU_t *m, char *decl, long value )
{
	return( var_set(m->vars,decl,value) );
}

int menu_do_command( MENU_t *m, int typ, char *cmd )
{ int i,n,c;
  char *s;
  vars_t *local;
  char *p;
  	if( cmd[0]=='?' && typ==MENU_ITEM )
  	{	menu_print_help(m->fd,m->menu);
		return(1);
  	}
	else if( cmd[0]=='?' )
		return(0);
	if( (local=var_init(m->vars->types))==NULL )
		return(-1);
	p=cmd;
	while( *p!=0 && *p!=' ' && *p!='\t' )	p++;
	while( *p==' ' || *p=='\t' )	p++;
	n=0;
	for(i=0;m->menu[i].typ!=MENU_END;)
	{	if( m->menu[i].typ==(typ|n)
		    && ( m->menu[i].command==NULL || m->menu[i].command[0]==0
			 || !cmdcmp(m->menu[i].command,cmd) )
		  )
		{	if( p!=NULL )
			{	var_set(local,"char *args",(long)strdup(p));
				p=NULL;
			}
//			if( m->menu[i].func!=NULL
//				|| m->menu[i].retval_dec!=NULL )
			  menu_exec_function(m->fd,m->vars,local,&(m->menu[i]));
			if( m->menu[i].func==NULL
				&& m->menu[i].retval_dec!=NULL )
			{	menu_extern_vars(m->vars,m->menu[i].retval_dec,
						local);
			}
			n++;
			i=0; continue;
		}
		else if( n==0 && (m->menu[i].typ & MENU_MASK)==MENU_SUB
			 && m->menu[i].func!=NULL
			 && (c=m->menu[i].typ & ~MENU_MASK)!=0
			 && (s=strchr(cmd,c))!=NULL
			 && !strncmp(m->menu[i].command,cmd,s-cmd) )
		{ MENU_t *sub;
			sub=menu_init(m->fd,m->vars->types,m->menu[i].func,NULL);
			if( sub!=NULL )
			{	sub->prev=m;
				if( m->menu[i].param_dec!=NULL )
					menu_extern_vars(sub->vars,
					m->menu[i].param_dec,m->vars);
				if( m->menu[i].retval_dec!=NULL )
					sub->retvars=
					   strdup(m->menu[i].retval_dec);
				n=menu_do_command(sub,typ,s+1);
				menu_exit(sub);
				if( typ==MENU_EXIT )	n=0;
				goto End;
			}
		}
		i++;
	}
End:	var_stop(local);
	return(n);
}

MENU_t *menu_enter_sub( MENU_t *m, char *cmd )
{ int i;
  MENU_t *sub;
	for(i=0;m->menu[i].typ!=MENU_END;)
	{	if( (m->menu[i].typ & MENU_MASK)==MENU_SUB
		    && m->menu[i].func!=NULL
		    && m->menu[i].command!=NULL 
		    && !cmdcmp(m->menu[i].command,cmd) )
		{	sub=menu_init(m->fd,m->vars->types,m->menu[i].func,NULL);
			if( sub!=NULL )
			{	sub->prev=m;
				if( m->menu[i].param_dec!=NULL )
					menu_extern_vars(sub->vars,
					m->menu[i].param_dec,m->vars);
				if( m->menu[i].retval_dec!=NULL )
					sub->retvars=
					   strdup(m->menu[i].retval_dec);
			}
			return(sub);
		}
		i++;
	}
	return(NULL);
}

/* --- menu_text_command --- */

static char *read_command( int fd )
{ char *p,*pp;
  int len,size;
  	len=0;
	size=16;
	if( (p=malloc(size))==NULL )	return(NULL);
  	while( read(fd,p+len,1)==1 )
	{	if( p[len]==0 || p[len]=='\n' )
			break;
		len++;
		if( len>=size )
		{	size=len+16;
			if( (p=realloc((pp=p),size))==NULL )
			{	pp[len-1]=0;
				return(pp);
			}
		}
	}
	p[len]=0;
	return(p);
}

int menu_text_command( MENU_t *m )
{ MENU_t *sub;
  int r;
  char *s;
	if( m==NULL )	return(-1);
	while( 1 )
	{
		if( m->prompt!=NULL )
			write(m->fd,m->prompt,strlen(m->prompt));
		if( (s=read_command(m->fd))==NULL )
		{	r=-1;	goto End;	}
		else if( menu_do_command(m,MENU_EXIT,s)>0 )
		{	m=menu_exit(m);
			if( m==NULL )
			{	r=0;	goto End;	}
		}
		else if( menu_do_command(m,MENU_ITEM,s)>0 )
			;
		else if( (sub=menu_enter_sub(m,s))!=NULL )
		{	m=sub;	}
		else
		{	if( m->not_found!=NULL )
				write(m->fd,m->not_found,strlen(m->not_found));
		}
		free(s); s=NULL;
	}
End:	while( m!=NULL )	m=menu_exit(m);
	return(r);
}

