/* Variables (C like)
 * (c) by Marek Zelem
 */

#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <mmm/menu.h>

int val_err;

vars_t *var_init( types_t *types )
{ vars_t *v;
	v=malloc(sizeof(vars_t));
	if( v!=NULL )
	{	v->types=types;
		v->vars=NULL;
	}
	return(v);
}

int var_set( vars_t *vars, char *decl, long value )
{ struct vars *new;
	new=vars->vars;
	while( new!=NULL )
	{	if( !declcmp(decl,new->decl) )
		{	type_free(new->decl,vars->types,new->value);
			new->value=value;
			val_err=0;
			return(0);
		}
		new=new->next;
	}
	if( (new=malloc(sizeof(struct vars)))==NULL )
	{	val_err=1;
		return( -1 );
	}
	new->next=vars->vars;
//	new->name=strdup(type_varname(decl));
	new->decl=strdup(decl);
	new->value=value;
	vars->vars=new;
	val_err=0;
	return(0);
}

long var_getval( vars_t *vars, char *decl )
{ struct vars *p;
	p=vars->vars;
	while( p!=NULL )
	{	if( !declcmp(decl,p->decl) )
		{	val_err=0;
			return(p->value);
		}
		p=p->next;
	}
	val_err=1;
	return(0);
}

int var_del( vars_t *vars, char *decl )
{ struct vars *p,*prev;
	p=vars->vars;
	prev=NULL;
	while( p!=NULL )
	{	if( !declcmp(decl,p->decl) )
		{	if( prev==NULL )
				vars->vars=p->next;
			else	prev->next=p->next;
			type_free(p->decl,vars->types,p->value);
			free(p->decl);
			free(p);
			val_err=0;
			return(0);
		}
		prev=p;
		p=p->next;
	}
	val_err=1;
	return(0);
}

int var_stop( vars_t *vars )
{ struct vars *p,*next;
	p=vars->vars;
	while( p!=NULL )
	{	next=p->next;
		type_free(p->decl,vars->types,p->value);
		free(p->decl);
		free(p);
		p=next;
	}
	free(vars);
	val_err=0;
	return(0);
}

