/* lock file */
/* (c) by Marek Zelem */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <time.h>
#include <fcntl.h>
#ifdef linux
#include <linux/limits.h>
#else
#include <limits.h>
#endif
#include <mmm/lockfile.h>

/* create_lockfile
 * lockdir - adresar v ktorom sa vyrobi lockfile
 * lockname - meno lock suboru.
 * timeout - pocet sekund, kolko sa maximalne caka. Potom return(-1)
 *           if timeout<=0 then no timeout.
 * RETURN Value 0 ak ok
 */
int create_lockfile( char *lockdir, char *lockname, long timeout )
{ char fname[PATH_MAX];
  char buf[128];
  int fd,pid,l;
  time_t t;
  	t=time(NULL)+timeout;
	snprintf(fname,PATH_MAX,"%s/%s",lockdir,lockname);
	fname[PATH_MAX-1]=0;
	for(;timeout<=0 || time(NULL)<t;)
	{	if( (fd=open(fname, O_WRONLY | O_CREAT | O_EXCL, 0600))<0 )
		{	if( (fd=open(fname,O_RDONLY))<0 ) continue;
			l=read(fd,buf,127);
			close(fd);
			if( l>0 )
			{	buf[l]=0;
				pid=atoi(buf);
				sprintf(buf,"/proc/%d",pid);
				if( access(buf, F_OK)<0 )
					unlink(fname);
				else	sleep(1);
			}
			else	sleep(1);
		}
		else
		{	sprintf(buf,"%d\n",getpid());
			write(fd,buf,strlen(buf));
			close(fd);
			return(0);
		}
	}
	return(-1);
}

/* delete_lockfile
 * return value as unlink
 */
int delete_lockfile( char *lockdir, char *lockname )
{ char fname[PATH_MAX];
	snprintf(fname,PATH_MAX,"%s/%s",lockdir,lockname);
	fname[PATH_MAX-1]=0;
	return(unlink(fname));
}
